/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20160729-64
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt10.dat, Sat Dec 15 20:11:44 2018
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00001A28 (6696)
 *     Revision         0x02
 *     Checksum         0x6F
 *     OEM ID           "INTEL "
 *     OEM Table ID     "PtidDevc"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20160527 (538314023)
 */
DefinitionBlock ("", "SSDT", 2, "INTEL ", "PtidDevc", 0x00001000)
{
    External (_SB_.DTS1, UnknownObj)
    External (_SB_.DTS2, UnknownObj)
    External (_SB_.DTS3, UnknownObj)
    External (_SB_.DTS4, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__, DeviceObj)
    External (_SB_.PCI0.LPCB.EC__.AMBT, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.CFSP, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.CPUE, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.CVRT, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.DIM0, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.DIM1, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.ECOK, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.FANT, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.FCMD, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.FDAT, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.GTVR, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PCAD, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PDT0, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PDT1, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PDT2, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PDT3, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PEC0, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PEC1, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PEC2, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PEC3, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PECC, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PECD, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PECH, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PECI, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PEHI, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PEPL, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PEPM, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PEWL, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PMAX, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PMDT, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PPDT, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PRC0, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PRC1, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PRCL, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PRCM, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PRCS, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PRFC, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PRIN, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PRS0, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PRS1, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PRS2, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PRS3, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PRS4, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PSTE, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PWFC, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.PWRL, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.SKNT, UnknownObj)
    External (_SB_.PDTS, UnknownObj)
    External (_TZ_.TZ0_._TMP, UnknownObj)
    External (PAMT, UnknownObj)
    External (TSDB, UnknownObj)

    Scope (\_SB)
    {
        Device (PTID)
        {
            Name (_HID, EisaId ("INT340E") /* Motherboard Resources */)  // _HID: Hardware ID
            Name (_CID, EisaId ("PNP0C02") /* PNP Motherboard Resources */)  // _CID: Compatible ID
            Name (IVER, 0x00030000)
            Name (_STA, 0x0F)  // _STA: Status
            Method (TSDL, 0, NotSerialized)
            {
                If (TSDB == One)
                {
                    Return (TSD2) /* \_SB_.PTID.TSD2 */
                }

                Return (TSD1) /* \_SB_.PTID.TSD1 */
            }

            Name (TSD1, Package (0x26)
            {
                Zero, 
                "CPU Core 0 DTS", 
                Zero, 
                "CPU Core 1 DTS", 
                Zero, 
                "CPU Core 2 DTS", 
                Zero, 
                "CPU Core 3 DTS", 
                Zero, 
                "CPU Core Package DTS", 
                0x03, 
                "DIMM0_hotspot_U4C1", 
                0x03, 
                "DIMM1_hotspot_Q4D1", 
                0x03, 
                "IMVP_conn_Q7C1", 
                0x03, 
                "board_hotspot1_U3G3", 
                0x03, 
                "board_hotspot2_Q3G1", 
                Zero, 
                "CPU Package Temperature", 
                0x05, 
                "PCH DTS Temperature from PCH", 
                Zero, 
                "CPU PECI reading", 
                0x05, 
                "SA DTS Temperature from PCH", 
                0x02, 
                "TZ00 _TMP", 
                0x03, 
                "SDRAM_hotspot_RT5B1", 
                0x03, 
                "NGFF_slot_RT6G1", 
                0x03, 
                "IMVP_conn_RT7D1", 
                0x03, 
                "board_hotspot3_RT8F1"
            })
            Name (TSD2, Package (0x26)
            {
                Zero, 
                "CPU Core 0 DTS", 
                Zero, 
                "CPU Core 1 DTS", 
                Zero, 
                "CPU Core 2 DTS", 
                Zero, 
                "CPU Core 3 DTS", 
                Zero, 
                "CPU Core Package DTS", 
                0x03, 
                "A-Skin Hotspot U21", 
                0x03, 
                "A-Skin Hotspot U21 IR", 
                0x03, 
                "B-Skin Hotspot U1", 
                0x03, 
                "B-Skin Hotspot U1 IR", 
                Zero, 
                "CPU Package Temperature", 
                0x05, 
                "PCH DTS Temperature from PCH", 
                Zero, 
                "CPU PECI reading", 
                0x05, 
                "SA DTS Temperature from PCH", 
                0x02, 
                "TZ00 _TMP", 
                0x03, 
                "SoC VR Thermsitor RT11", 
                0x03, 
                "Memory Thermistor RT9", 
                0x03, 
                "GNSS Board Ambient Thermistor R4", 
                0x03, 
                "System VR Thermistor RT10", 
                0x03, 
                "A-Skin MipiCam Thermistor RT8"
            })
            Name (PSDL, Package (0x26)
            {
                0x0B, 
                "Platform Power (mW)", 
                0x0B, 
                "Brick Power cW(100ths)", 
                0x0B, 
                "Battery Discharge Power cW(100ths)", 
                0x0B, 
                "Platform Average Power (mW)", 
                0x0B, 
                "Brick Average Power cW(0.01)", 
                0x0B, 
                "Battery Discharge Average Power cW(0.01)", 
                0x0C, 
                "Battery 1 Design Capacity (mWh)", 
                0x0C, 
                "Battery 1 Remaining Capacity (mWh)", 
                0x0C, 
                "Battery 1 Full Charge Capacity (mWh)", 
                0x0C, 
                "Battery 1 Full Resolution Voltage (mV)", 
                0x0C, 
                "Battery 1 Full Resolution Discharge Current (mA)", 
                0x0C, 
                "Battery 1 Full Resolution Charge Current (mA)", 
                0x0C, 
                "Battery 2 Remaining Capacity (mWh)", 
                0x0C, 
                "Battery 2 Full Charge Capacity (mWh)", 
                0x0C, 
                "Battery 2 Full Resolution Voltage (mV)", 
                0x0C, 
                "Battery 2 Full Resolution Discharge Current (mA)", 
                0x0C, 
                "Battery 2 Full Resolution Charge Current (mA)", 
                0x0C, 
                "Battery Pack 1 maximum power (mW)", 
                0x0C, 
                "Battery Pack 2 maximum power (mW)"
            })
            Method (OSDL, 0, NotSerialized)
            {
                If (TSDB == One)
                {
                    Return (OSD2) /* \_SB_.PTID.OSD2 */
                }

                Return (OSD1) /* \_SB_.PTID.OSD1 */
            }

            Name (OSD1, Package (0x15)
            {
                0x04, 
                "CPU Fan Duty Cycle", 
                "RAW", 
                0x04, 
                "CPU Fan #1 Speed", 
                "RPM", 
                0x03, 
                "Skin Temp 0", 
                "RAW", 
                0x03, 
                "Thermistor 1 ", 
                "RAW", 
                0x03, 
                "Thermistor 2 ", 
                "RAW", 
                0x03, 
                "Thermistor 3 ", 
                "RAW", 
                0x03, 
                "Thermistor 4 ", 
                "RAW"
            })
            Name (OSD2, Package (0x18)
            {
                0x04, 
                "CPU Fan Duty Cycle", 
                "RAW", 
                0x04, 
                "CPU Fan #1 Speed", 
                "RPM", 
                0x03, 
                "Skin Temp 0", 
                "RAW", 
                0x03, 
                "Thermistor 1 ", 
                "RAW", 
                0x03, 
                "Thermistor 2 ", 
                "RAW", 
                0x03, 
                "Thermistor 3 ", 
                "RAW", 
                0x03, 
                "Thermistor 4 ", 
                "RAW", 
                0x03, 
                "Thermistor 5 ", 
                "RAW"
            })
            Method (TSDD, 0, Serialized)
            {
                If (TSDB == One)
                {
                    Name (TMPX, Package (0x13)
                    {
                        0x80000000, 
                        0x80000000, 
                        0x80000000, 
                        0x80000000, 
                        0x80000000, 
                        0x80000000, 
                        0x80000000, 
                        0x80000000, 
                        0x80000000, 
                        0x80000000, 
                        0x80000000, 
                        0x80000000, 
                        0x80000000, 
                        0x80000000, 
                        0x80000000, 
                        0x80000000, 
                        0x80000000, 
                        0x80000000, 
                        0x80000000
                    })
                    TMPX [Zero] = ((\_SB.DTS1 * 0x0A) + 0x0AAC)
                    TMPX [One] = ((\_SB.DTS2 * 0x0A) + 0x0AAC)
                    TMPX [0x02] = ((\_SB.DTS3 * 0x0A) + 0x0AAC)
                    TMPX [0x03] = ((\_SB.DTS4 * 0x0A) + 0x0AAC)
                    TMPX [0x04] = ((\_SB.PDTS * 0x0A) + 0x0AAC)
                    Return (TMPX) /* \_SB_.PTID.TSDD.TMPX */
                }

                Name (TMPV, Package (0x14)
                {
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000
                })
                TMPV [Zero] = ((\_SB.DTS1 * 0x0A) + 0x0AAC)
                TMPV [One] = ((\_SB.DTS2 * 0x0A) + 0x0AAC)
                TMPV [0x02] = ((\_SB.DTS3 * 0x0A) + 0x0AAC)
                TMPV [0x03] = ((\_SB.DTS4 * 0x0A) + 0x0AAC)
                TMPV [0x04] = ((\_SB.PDTS * 0x0A) + 0x0AAC)
                If (\_SB.PCI0.LPCB.EC.ECOK)
                {
                    TMPV [0x05] = ((\_SB.PCI0.LPCB.EC.CVRT * 0x0A) + 0x0AAC)
                    TMPV [0x06] = ((\_SB.PCI0.LPCB.EC.FANT * 0x0A) + 0x0AAC)
                    TMPV [0x07] = ((\_SB.PCI0.LPCB.EC.SKNT * 0x0A) + 0x0AAC)
                    TMPV [0x08] = ((\_SB.PCI0.LPCB.EC.AMBT * 0x0A) + 0x0AAC)
                    TMPV [0x0A] = ((\_SB.PCI0.LPCB.EC.DIM0 * 0x0A) + 0x0AAC)
                    TMPV [0x0B] = ((\_SB.PCI0.LPCB.EC.DIM1 * 0x0A) + 0x0AAC)
                    TMPV [0x0C] = ((\_SB.PCI0.LPCB.EC.PMAX * 0x0A) + 0x0AAC)
                    TMPV [0x0D] = ((\_SB.PCI0.LPCB.EC.PPDT * 0x0A) + 0x0AAC)
                    TMPV [0x0E] = ((\_SB.PCI0.LPCB.EC.PECH * 0x0A) + 0x0AAC)
                    TMPV [0x0F] = ((\_SB.PCI0.LPCB.EC.PMDT * 0x0A) + 0x0AAC)
                }

                TMPV [0x10] = \_TZ.TZ0._TMP /* External reference */
                TMPV [0x11] = \_TZ.TZ0._TMP /* External reference */
                Return (TMPV) /* \_SB_.PTID.TSDD.TMPV */
            }

            Method (PSDD, 0, Serialized)
            {
                Name (PWRV, Package (0x13)
                {
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000
                })
                Return (PWRV) /* \_SB_.PTID.PSDD.PWRV */
            }

            Method (OSDD, 0, Serialized)
            {
                Return (Package (0x00) {})
            }

            Method (SDSP, 0, NotSerialized)
            {
                Return (0x0A)
            }

            Name (PADA, Package (0x0A)
            {
                One, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0x1A, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF
            })
            Name (PADD, Package (0x0A)
            {
                0x02, 
                0x06A4, 
                0x06A0, 
                0x1A, 
                0x62, 
                0x63, 
                0x60, 
                0x61, 
                0x65, 
                0x64
            })
            Method (PADT, 0, NotSerialized)
            {
                If (PAMT)
                {
                    Return (PADA) /* \_SB_.PTID.PADA */
                }

                Return (PADD) /* \_SB_.PTID.PADD */
            }

            Method (RPMD, 0, Serialized)
            {
                Name (MTMP, Buffer (0x1A) {})
                If (\_SB.PCI0.LPCB.EC.ECOK)
                {
                    MTMP [Zero] = \_SB.PCI0.LPCB.EC.PRCL /* External reference */
                    MTMP [One] = \_SB.PCI0.LPCB.EC.PRC0 /* External reference */
                    MTMP [0x02] = \_SB.PCI0.LPCB.EC.PRC1 /* External reference */
                    MTMP [0x03] = \_SB.PCI0.LPCB.EC.PRCM /* External reference */
                    MTMP [0x04] = \_SB.PCI0.LPCB.EC.PRIN /* External reference */
                    MTMP [0x05] = \_SB.PCI0.LPCB.EC.PSTE /* External reference */
                    MTMP [0x06] = \_SB.PCI0.LPCB.EC.PCAD /* External reference */
                    MTMP [0x07] = \_SB.PCI0.LPCB.EC.PEWL /* External reference */
                    MTMP [0x08] = \_SB.PCI0.LPCB.EC.PWRL /* External reference */
                    MTMP [0x09] = \_SB.PCI0.LPCB.EC.PECD /* External reference */
                    MTMP [0x0A] = \_SB.PCI0.LPCB.EC.PEHI /* External reference */
                    MTMP [0x0B] = \_SB.PCI0.LPCB.EC.PECI /* External reference */
                    MTMP [0x0C] = \_SB.PCI0.LPCB.EC.PEPL /* External reference */
                    MTMP [0x0D] = \_SB.PCI0.LPCB.EC.PEPM /* External reference */
                    MTMP [0x0E] = \_SB.PCI0.LPCB.EC.PWFC /* External reference */
                    MTMP [0x0F] = \_SB.PCI0.LPCB.EC.PECC /* External reference */
                    MTMP [0x10] = \_SB.PCI0.LPCB.EC.PDT0 /* External reference */
                    MTMP [0x11] = \_SB.PCI0.LPCB.EC.PDT1 /* External reference */
                    MTMP [0x12] = \_SB.PCI0.LPCB.EC.PDT2 /* External reference */
                    MTMP [0x13] = \_SB.PCI0.LPCB.EC.PDT3 /* External reference */
                    MTMP [0x14] = \_SB.PCI0.LPCB.EC.PRFC /* External reference */
                    MTMP [0x15] = \_SB.PCI0.LPCB.EC.PRS0 /* External reference */
                    MTMP [0x16] = \_SB.PCI0.LPCB.EC.PRS1 /* External reference */
                    MTMP [0x17] = \_SB.PCI0.LPCB.EC.PRS2 /* External reference */
                    MTMP [0x18] = \_SB.PCI0.LPCB.EC.PRS3 /* External reference */
                    MTMP [0x19] = \_SB.PCI0.LPCB.EC.PRS4 /* External reference */
                }

                Return (MTMP) /* \_SB_.PTID.RPMD.MTMP */
            }

            Method (WPMD, 1, NotSerialized)
            {
                If (SizeOf (Arg0) != 0x1A)
                {
                    Return (0xFFFFFFFF)
                }

                If (\_SB.PCI0.LPCB.EC.ECOK)
                {
                    \_SB.PCI0.LPCB.EC.PRCL = DerefOf (Arg0 [Zero])
                    \_SB.PCI0.LPCB.EC.PRC0 = DerefOf (Arg0 [One])
                    \_SB.PCI0.LPCB.EC.PRC1 = DerefOf (Arg0 [0x02])
                    \_SB.PCI0.LPCB.EC.PRCM = DerefOf (Arg0 [0x03])
                    \_SB.PCI0.LPCB.EC.PRIN = DerefOf (Arg0 [0x04])
                    \_SB.PCI0.LPCB.EC.PSTE = DerefOf (Arg0 [0x05])
                    \_SB.PCI0.LPCB.EC.PCAD = DerefOf (Arg0 [0x06])
                    \_SB.PCI0.LPCB.EC.PEWL = DerefOf (Arg0 [0x07])
                    \_SB.PCI0.LPCB.EC.PWRL = DerefOf (Arg0 [0x08])
                    \_SB.PCI0.LPCB.EC.PECD = DerefOf (Arg0 [0x09])
                    \_SB.PCI0.LPCB.EC.PEHI = DerefOf (Arg0 [0x0A])
                    \_SB.PCI0.LPCB.EC.PECI = DerefOf (Arg0 [0x0B])
                    \_SB.PCI0.LPCB.EC.PEPL = DerefOf (Arg0 [0x0C])
                    \_SB.PCI0.LPCB.EC.PEPM = DerefOf (Arg0 [0x0D])
                    \_SB.PCI0.LPCB.EC.PWFC = DerefOf (Arg0 [0x0E])
                    \_SB.PCI0.LPCB.EC.PECC = DerefOf (Arg0 [0x0F])
                    \_SB.PCI0.LPCB.EC.PDT0 = DerefOf (Arg0 [0x10])
                    \_SB.PCI0.LPCB.EC.PDT1 = DerefOf (Arg0 [0x11])
                    \_SB.PCI0.LPCB.EC.PDT2 = DerefOf (Arg0 [0x12])
                    \_SB.PCI0.LPCB.EC.PDT3 = DerefOf (Arg0 [0x13])
                    \_SB.PCI0.LPCB.EC.PRFC = DerefOf (Arg0 [0x14])
                    \_SB.PCI0.LPCB.EC.PRS0 = DerefOf (Arg0 [0x15])
                    \_SB.PCI0.LPCB.EC.PRS1 = DerefOf (Arg0 [0x16])
                    \_SB.PCI0.LPCB.EC.PRS2 = DerefOf (Arg0 [0x17])
                    \_SB.PCI0.LPCB.EC.PRS3 = DerefOf (Arg0 [0x18])
                    \_SB.PCI0.LPCB.EC.PRS4 = DerefOf (Arg0 [0x19])
                    \_SB.PCI0.LPCB.EC.FCMD = 0xB4
                }

                Return (Zero)
            }

            Method (ISPC, 0, NotSerialized)
            {
                Return (Zero)
            }

            Method (ENPC, 0, NotSerialized)
            {
                Return (Zero)
            }

            Method (RPCS, 0, NotSerialized)
            {
                If (\_SB.PCI0.LPCB.EC.ECOK)
                {
                    Local0 = \_SB.PCI0.LPCB.EC.PRCS /* External reference */
                }

                Return (Local0)
            }

            Method (RPEC, 0, NotSerialized)
            {
                Local0 = Zero
                If (\_SB.PCI0.LPCB.EC.ECOK)
                {
                    Local1 = \_SB.PCI0.LPCB.EC.PEC0 /* External reference */
                    Local0 |= Local1
                    Local1 = \_SB.PCI0.LPCB.EC.PEC1 /* External reference */
                    Local0 |= (Local1 << 0x08)
                    Local1 = \_SB.PCI0.LPCB.EC.PEC2 /* External reference */
                    Local0 |= (Local1 << 0x10)
                    Local1 = \_SB.PCI0.LPCB.EC.PEC3 /* External reference */
                    Local0 |= (Local1 << 0x18)
                }

                Return (Local0)
            }
        }
    }
}

